/**
 * Copyright (c) 2014-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jmx.api.impl.mbean;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import javax.jbi.messaging.MessagingException;
import javax.xml.namespace.QName;

/**
 * A Mbean implementation for the router monitor service used as mock for unit test purposes
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public class RouterMonitorService implements RouterMonitorServiceMBean {

    @Override
    public void clearMonitorStorage() {
        // NOP
    }

    @Override
    public Map<String, String> getExchange(final String exchangeId) throws MessagingException {
        return null;
    }

    @Override
    public Map<String, Long> getExchangeHistory(final String exchangeId) throws MessagingException {
        return null;
    }

    @Override
    public List<String> getExchangeIds(final QName interfaceName, final QName serviceName, final String endpointName,
            final QName operationName, final long startDate, final long endDate) throws MessagingException {
        return null;
    }

    @Override
    public List<String> getExchangeIds(final String propertyKey, final String propertyValue) throws MessagingException,
            IOException {
        return null;
    }

    @Override
    public int getExchanges(final QName interfaceName, final QName serviceName, final String endpointName,
            final QName operationName, final long startDate, final long endDate) throws MessagingException {
        return 0;
    }

    @Override
    public List<Map<String, String>> getMonitoredExchanges() {
        return null;
    }

    @Override
    public void monitorExchanges(final QName interfaceName, final QName serviceName, final String endpointName,
            final QName operationName, boolean storeExchanges) throws MessagingException {
        // NOP
    }

    @Override
    public void setMonitorStorageDuration(final long duration) {
        // NOP
    }

    @Override
    public long getMonitorStorageDuration() {
        return 0;
    }

    @Override
    public void unmonitorExchanges(final QName interfaceName, final QName serviceName, final String endpointName,
            final QName operationName) throws MessagingException {
        // NOP
    }
}
