/**
 * Copyright (c) 2014-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jmx.api.impl.mbean.monitoring.component.framework;

import java.util.HashMap;
import java.util.Map;

import org.ow2.petals.component.framework.clientserver.api.monitoring.exception.MonitoringProbeNotInitializedException;
import org.ow2.petals.component.framework.clientserver.api.monitoring.exception.MonitoringProbeNotStartedException;
import org.ow2.petals.component.framework.clientserver.api.monitoring.exception.MonitoringServiceException;

/**
 * A Mbean implementation for the component monitoring service used as mock for unit test purposes
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public class ComponentMonitoringService implements ComponentMonitoringServiceMBean {

    private int messageExchangeProcessorThreadPoolAllocatedThreadsCurrent = 0;

    @Override
    public int getMessageExchangeAcceptorThreadPoolMaxSize() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public int getMessageExchangeAcceptorThreadPoolCurrentSize() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolMaxSize() throws MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolMinSize() throws MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolAllocatedThreadsMax()
            throws MonitoringProbeNotInitializedException, MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolAllocatedThreadsCurrent()
            throws MonitoringProbeNotStartedException, MonitoringServiceException {
        return this.messageExchangeProcessorThreadPoolAllocatedThreadsCurrent;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolIdleThreadsMax() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolIdleThreadsCurrent() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolQueuedRequestsMax() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorThreadPoolQueuedRequestsCurrent() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolMaxSize() throws MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolMinIdleSize() throws MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolBorrowedObjectsMax()
            throws MonitoringProbeNotInitializedException, MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolBorrowedObjectsCurrent()
            throws MonitoringProbeNotStartedException, MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolIdleObjectsMax() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolIdleObjectsCurrent() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeProcessorObjectPoolExhaustion() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public Long[] getMessageExchangeProcessorAbsoluteDurations() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return null;
    }

    @Override
    public Long[] getMessageExchangeProcessorRelativeDurations() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return new Long[] {};
    }

    @Override
    public Map<String[], Long[]> getServiceProviderInvokationsResponseTimeAbs()
            throws MonitoringProbeNotInitializedException, MonitoringServiceException {
        return new HashMap<String[], Long[]>();
    }

    @Override
    public Map<String[], Long[]> getServiceProviderInvokationsResponseTimeRel()
            throws MonitoringProbeNotStartedException, MonitoringServiceException {
        return new HashMap<String[], Long[]>();
    }

    @Override
    public Map<String[], Long[]> getServiceProviderInvokationsResponseTimeRelGroupedByItfSvcOpAndExecStatus()
            throws MonitoringProbeNotStartedException, MonitoringServiceException {
        return new HashMap<String[], Long[]>();
    }

    @Override
    public Map<String[], Long> getServiceProviderInvokations() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return new HashMap<String[], Long>();
    }

    @Override
    public long getMessageExchangeAcceptorCurrentWorking() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public long getMessageExchangeAcceptorMaxWorking() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return 0;
    }

    @Override
    public Long[] getMessageExchangeAcceptorAbsoluteDurations() throws MonitoringProbeNotInitializedException,
            MonitoringServiceException {
        return new Long[] {};
    }

    @Override
    public Long[] getMessageExchangeAcceptorRelativeDurations() throws MonitoringProbeNotStartedException,
            MonitoringServiceException {
        return new Long[] {};
    }

    public void setMessageExchangeProcessorThreadPoolAllocatedThreadsCurrent(
            final int messageExchangeProcessorThreadPoolAllocatedThreadsCurrent) {
        this.messageExchangeProcessorThreadPoolAllocatedThreadsCurrent = messageExchangeProcessorThreadPoolAllocatedThreadsCurrent;
    }
}
